/*
	MirandaRPC Plugin for Miranda-IM (http://www.miranda-im.org)
	Copyright 2004/2005 P. Boon

	This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* error value for number of queued events */
#define MAX_EVENTCOUNT		100

/* default RPC values */
#define RPC_DEF_ENDPOINT	"MirandaRPC"
#define RPC_DEF_TCPENDPOINT	"1125"
#define RPC_DEF_PROTOSEQ	"ncalrpc"
#define RPC_DEF_MAXCALLS	RPC_C_PROTSEQ_MAX_REQS_DEFAULT
#define RPC_DEF_MINCALLS	1

/* event types */
#define EF_UNKNOWN			0x00000001
#define EF_MESSAGE			0x00000002
#define EF_URL				0x00000004
#define EF_USERONLINE		0x00000008
#define EF_AUTH_SHOWREQ		0x00000010
#define EF_AUTH_SHOWADDED	0x00000020
#define EF_FILE				0x00000040
#define EF_TYPING			0x00000080

/* status flags */
#define SF_OFFLINE		0x00000001
#define SF_ONLINE       0x00000002
#define SF_INVISIBLE    0x00000004
#define SF_AWAY			0x00000008
#define SF_NA			0x00000010
#define SF_OCCUPIED     0x00000020
#define SF_DND			0x00000040
#define SF_FREECHAT     0x00000080
#define SF_OUTTOLUNCH   0x00000100
#define SF_ONTHEPHONE   0x00000200
#define SF_UNKNOWN		0x00000400

#define ID_STATUS_UNKNOWN	MAX_CONNECT_RETRIES+1

/* contact info flags */
#define CNF_FIRSTNAME	1  // returns first name (string)
#define CNF_LASTNAME	2  // returns last name (string)
#define CNF_NICK		3  // returns nick name (string)
#define	CNF_CUSTOMNICK	4  // returns custom nick name, clist name (string)
#define CNF_EMAIL		5  // returns email (string)
#define CNF_CITY		6  // returns city (string)
#define CNF_STATE		7  // returns state (string)
#define CNF_COUNTRY		8  // returns country (string)
#define CNF_PHONE		9  // returns phone (string)
#define CNF_HOMEPAGE	10 // returns homepage (string)
#define CNF_ABOUT		11 // returns about info (string)
#define CNF_GENDER		12 // returns gender (byte,'M','F' character)
#define CNF_AGE			13 // returns age (byte, 0==unspecified)
#define CNF_FIRSTLAST	14 // returns first name + last name (string)
#define CNF_UNIQUEID	15 // returns uniqueid, protocol username (must check type for type of return)
#define CNF_DISPLAY		16 // returns the custom name using the name order setting
#define CNF_DISPLAYNC	17 // same as CNF_DISPLAY except the custom handle is not used
#define CCNF_PROTOCOL	18 // CUSTOM, returns the contact's protocol (human-readable)
#define CCNF_STATUS		19	// CUSTOM, returns status mode description
#define CCNF_AVATAR		20 // CUSTOM, returns filename of the avatar (or NULL)