/*
	Miranda-IM Plugin for Serious Samurize (http://www.samurize.com)
	Copyright 2004/2005 P. Boon

	This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __SAMMIRANDA__
#define __SAMMIRANDA__

#include "AggressiveOptimize.h"
#include <windows.h>
#include <stdio.h>
#include "..\Interface\MirandaRPCCommon.h"
#include "..\Interface\MirandaRPC.h"
#include "..\..\..\include\statusmodes.h"

#define SAMURIZE_PLUGIN_CHAR  extern "C" __declspec(dllexport) char* __stdcall
#define SAMURIZE_PLUGIN_INT   extern "C" __declspec(dllexport) int __stdcall

/* status strings */

#define STR_NOT			"not"
#define STR_ALL			"all"
#define STR_OFFLINE		"offline"
#define STR_ONLINE		"online"
#define STR_AWAY		"away"
#define STR_NA			"na"
#define STR_OCCUPIED	"occupied"
#define STR_DND			"dnd"
#define STR_INVISIBLE	"invisible"
#define STR_FREECHAT	"freeforchat"
#define STR_OUTTOLUNCH	"outtolunch"
#define STR_ONTHEPHONE	"onthephone"
#define STR_UNKNOWN		"unknown"
#define STR_CONNECTING	"connecting"

#define STR_MESSAGE			"message"
#define STR_URL				"url"
#define STR_USERONLINE		"useronline"
#define STR_AUTH_SHOWREQ	"authreq"
#define STR_AUTH_SHOWADDED	"authadded"
#define STR_FILE			"file"
#define STR_TYPING			"typing"
#define STR_NONE			"none"

#define STR_FIRSTNAME	"first"
#define STR_LASTNAME	"last"
#define STR_NICK		"nick"
#define	STR_CUSTOMNICK	"cnick"
#define STR_EMAIL		"email"
#define STR_CITY		"city"
#define STR_STATE		"state"
#define STR_COUNTRY		"country"
#define STR_PHONE		"phone"
#define STR_HOMEPAGE	"homepage"
#define STR_ABOUT		"about"
#define STR_GENDER		"gender"
#define STR_AGE			"age"
#define STR_FIRSTLAST	"firstlast"
#define STR_UNIQUEID	"id"
#define STR_DISPLAY		"display"

#define STR_PROTOCOL	"protocol"
#define STR_STATUS		"status"
#define STR_AVATAR		"avatar"
#define STR_VARIABLES	"var"

#define MAX_CNF			20
#define SORT_DISPLAY	MAX_CNF+1
#define SORT_STATUS		MAX_CNF+2
#define CCNF_VARIABLES	MAX_CNF+3

#define INI_FILENAME	"\\plugins\\miranda.ini"

unsigned int getStatusFlags(char* status);
unsigned int getContactInfoType(char* type);
char *getStatusDesc(int status);
unsigned int getEventFlags(char *type);
char* getTypeDesc(unsigned int eventType);
int compareContacts(const void *arg1, const void *arg2);
int getSortType(char *type);


typedef struct {
	unsigned int hContact;
	unsigned char *szDisplay;
	unsigned char *szContactInfo;
	unsigned int status;
	int sortBy;
} CONTACTINFO;

#endif