/*
	Miranda-IM Plugin for Serious Samurize (http://www.samurize.com)
	Copyright 2004/2005 P. Boon

	This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "SamMiranda.h"

struct {
	int status,order;
} statusModeOrder[]={
	{ID_STATUS_UNKNOWN,550},
	{ID_STATUS_OFFLINE,500},
	{ID_STATUS_ONLINE,0},
	{ID_STATUS_AWAY,200},
	{ID_STATUS_DND,400},
	{ID_STATUS_NA,450},
	{ID_STATUS_OCCUPIED,100},
	{ID_STATUS_FREECHAT,50},
	{ID_STATUS_INVISIBLE,20},
	{ID_STATUS_ONTHEPHONE,150},
	{ID_STATUS_OUTTOLUNCH,425}};

unsigned int getStatusFlags(char* status) {

	unsigned int sFlags, tsFlags;
	char *cur;

	if ( (status == NULL) || (strlen(status) == 0) ) return 0xFFFFFFFF;
	if (!strcmp(status, STR_ALL)) return 0xFFFFFFFF;
	sFlags = 0;
	cur = status;
	while (cur < status+strlen(status)) {
		if (!_strnicmp(cur, STR_NOT, strlen(STR_NOT))) {
			tsFlags = 0xFFFFFFFF;
			cur += 3;
		}
		else tsFlags = 0;
		if (!_strnicmp(cur, STR_OFFLINE, strlen(STR_OFFLINE))) {
			tsFlags ^= SF_OFFLINE;
			cur += strlen(STR_OFFLINE);
		}
		else if (!_strnicmp(cur, STR_ONLINE, strlen(STR_ONLINE))) {
			tsFlags ^= SF_ONLINE;
			cur += strlen(STR_ONLINE);
		}
		else if (!_strnicmp(cur, STR_AWAY, strlen(STR_AWAY))) {
			tsFlags ^= SF_AWAY;
			cur += strlen(STR_AWAY);
		}
		else if (!_strnicmp(cur, STR_NA, strlen(STR_NA))) {
			tsFlags ^= SF_NA;
			cur += strlen(STR_NA);
		}
		else if (!_strnicmp(cur, STR_OCCUPIED, strlen(STR_OCCUPIED))) {
			tsFlags ^= SF_OCCUPIED;
			cur += strlen(STR_OCCUPIED);
		}
		else if (!_strnicmp(cur, STR_DND, strlen(STR_DND))) {
			tsFlags ^= SF_DND;
			cur += strlen(STR_DND);
		}
		else if (!_strnicmp(cur, STR_INVISIBLE, strlen(STR_INVISIBLE))) {
			tsFlags ^= SF_INVISIBLE;
			cur += strlen(STR_INVISIBLE);
		}
		else if (!_strnicmp(cur, STR_FREECHAT, strlen(STR_FREECHAT))) {
			tsFlags ^= SF_FREECHAT;
			cur += strlen(STR_FREECHAT);
		}
		else if (!_strnicmp(cur, STR_OUTTOLUNCH, strlen(STR_OUTTOLUNCH))) {
			tsFlags ^= SF_OUTTOLUNCH;
			cur += strlen(STR_OUTTOLUNCH);
		}
		else if (!_strnicmp(cur, STR_ONTHEPHONE, strlen(STR_ONTHEPHONE))) {
			tsFlags ^= SF_ONTHEPHONE;
			cur += strlen(STR_ONTHEPHONE);
		}
		else if (!_strnicmp(cur, STR_UNKNOWN, strlen(STR_UNKNOWN))) {
			tsFlags ^= SF_UNKNOWN;
			cur += strlen(STR_UNKNOWN);
		}
		sFlags |= tsFlags;
		if (*cur == '|')
			cur++;
		else return sFlags;
	}

	return sFlags;
}

unsigned int getContactInfoType(char* type) {

	if ( (type == NULL) || (strlen(type) == 0) ) return 0;
	if (!_stricmp(type, STR_FIRSTNAME))
		return CNF_FIRSTNAME;
	else if (!_stricmp(type, STR_LASTNAME))
		return CNF_LASTNAME;
	else if (!_stricmp(type, STR_NICK))
		return CNF_NICK;
	else if (!_stricmp(type, STR_CUSTOMNICK))
		return CNF_CUSTOMNICK;
	else if (!_stricmp(type, STR_EMAIL))
		return CNF_EMAIL;
	else if (!_stricmp(type, STR_CITY))
		return CNF_CITY;
	else if (!_stricmp(type, STR_STATE))
		return CNF_STATE;
	else if (!_stricmp(type, STR_COUNTRY))
		return CNF_COUNTRY;
	else if (!_stricmp(type, STR_PHONE))
		return CNF_PHONE;
	else if (!_stricmp(type, STR_HOMEPAGE))
		return CNF_HOMEPAGE;
	else if (!_stricmp(type, STR_ABOUT))
		return CNF_ABOUT;
	else if (!_stricmp(type, STR_GENDER))
		return CNF_GENDER;
	else if (!_stricmp(type, STR_AGE))
		return CNF_AGE;
	else if (!_stricmp(type, STR_FIRSTLAST))
		return CNF_FIRSTLAST;
	else if (!_stricmp(type, STR_UNIQUEID))
		return CNF_UNIQUEID;
	else if (!_stricmp(type, STR_DISPLAY))
		return CNF_DISPLAY;
	else if (!_stricmp(type, STR_PROTOCOL))
		return CCNF_PROTOCOL;
	else if (!_stricmp(type, STR_STATUS))
		return CCNF_STATUS;
	else if (!_stricmp(type, STR_AVATAR))
		return CCNF_AVATAR;
	else if (!_strnicmp(type, STR_VARIABLES, strlen(STR_VARIABLES)))
		return CCNF_VARIABLES;

	return 0;
}

char *getStatusDesc(int status) {

	switch(status) {
	case ID_STATUS_OFFLINE:
		return STR_OFFLINE;
		break;
	case ID_STATUS_ONLINE:
		return STR_ONLINE;
		break;
	case ID_STATUS_AWAY:
		return STR_AWAY;
		break;
	case ID_STATUS_NA:
		return STR_NA;
		break;
	case ID_STATUS_OCCUPIED:
		return STR_OCCUPIED;
		break;
	case ID_STATUS_DND:
		return STR_DND;
		break;
	case ID_STATUS_INVISIBLE:
		return STR_INVISIBLE;
		break;
	case ID_STATUS_FREECHAT:
		return STR_FREECHAT;
		break;
	case ID_STATUS_OUTTOLUNCH:
		return STR_OUTTOLUNCH;
		break;
	case ID_STATUS_ONTHEPHONE:
		return STR_ONTHEPHONE;
		break;
	}
	
	if (status < MAX_CONNECT_RETRIES) 
		return STR_CONNECTING;
	else 
		return STR_UNKNOWN;
}

unsigned int getEventFlags(char *type) {

	unsigned int tFlags, ttFlags;
	char *cur;

	if ( (type == NULL) || (strlen(type) == 0) ) return 0xFFFFFFFF;
	if (!strcmp(type, STR_ALL)) return 0xFFFFFFFF;
	tFlags = 0;
	cur = type;
	while (cur < type+strlen(type)) {
		if (!_strnicmp(cur, STR_NOT, strlen(STR_NOT))) {
			ttFlags = 0xFFFFFFFF;
			cur += 3;
		}
		else ttFlags = 0;
		if (!_strnicmp(cur, STR_MESSAGE, strlen(STR_MESSAGE))) {
			ttFlags ^= EF_MESSAGE;
			cur += strlen(STR_MESSAGE);
		}
		else if (!_strnicmp(cur, STR_URL, strlen(STR_URL))) {
			ttFlags ^= EF_URL;
			cur += strlen(STR_URL);
		}
		else if (!_strnicmp(cur, STR_USERONLINE, strlen(STR_USERONLINE))) {
			ttFlags ^= EF_USERONLINE;
			cur += strlen(STR_USERONLINE);
		}
		else if (!_strnicmp(cur, STR_AUTH_SHOWREQ, strlen(STR_AUTH_SHOWREQ))) {
			ttFlags ^= EF_AUTH_SHOWREQ;
			cur += strlen(STR_AUTH_SHOWREQ);
		}
		else if (!_strnicmp(cur, STR_AUTH_SHOWADDED, strlen(STR_AUTH_SHOWADDED))) {
			ttFlags ^= EF_AUTH_SHOWADDED;
			cur += strlen(STR_AUTH_SHOWADDED);
		}
		else if (!_strnicmp(cur, STR_FILE, strlen(STR_FILE))) {
			ttFlags ^= EF_FILE;
			cur += strlen(STR_FILE);
		}
		else if (!_strnicmp(cur, STR_TYPING, strlen(STR_TYPING))) {
			ttFlags ^= EF_TYPING;
			cur += strlen(STR_TYPING);
		}
		tFlags |= ttFlags;
		if (*cur == '|')
			cur++;
		else return tFlags;
	}

	return tFlags;

}

char* getTypeDesc(unsigned int eventType) {

	switch(eventType) {
	case 0:
		return STR_NONE;
		break;
	case EF_MESSAGE:
		return STR_MESSAGE;
		break;
	case EF_URL:
		return STR_URL;
		break;
	case EF_USERONLINE:
		return STR_USERONLINE;
		break;
	case EF_AUTH_SHOWREQ:
		return STR_AUTH_SHOWREQ;
		break;
	case EF_AUTH_SHOWADDED:
		return STR_AUTH_SHOWADDED;
		break;
	case EF_FILE:
		return STR_FILE;
		break;
	case EF_TYPING:
		return STR_TYPING;
		break;
	}
	return STR_UNKNOWN;
}

// from contact.c
// source code of Miranda-IM can be found on http://www.miranda-im.org/
static int GetStatusModeOrdering(int statusMode)
{
	int i;
	for(i=0;i<sizeof(statusModeOrder)/sizeof(statusModeOrder[0]);i++)
		if(statusModeOrder[i].status==statusMode) return statusModeOrder[i].order;
	return 1000;
}

int compareContacts(const void *arg1, const void *arg2) {

	CONTACTINFO *ci1, *ci2;
	int res;

	res = 0;
	ci1 = (CONTACTINFO *)arg1;
	ci2 = (CONTACTINFO *)arg2;
	if ( (ci1->sortBy == SORT_DISPLAY) && (ci1->szDisplay != NULL) && (ci2->szDisplay != NULL) )
		return _stricmp((char *)ci1->szDisplay, (char *)ci2->szDisplay);
	else if (ci1->sortBy == SORT_STATUS) {
		int a, b;
		
		a = GetStatusModeOrdering(ci1->status);
		b = GetStatusModeOrdering(ci2->status);
		res = a-b;
	}
	else if ( (ci1->szContactInfo != NULL) && (ci2->szContactInfo != NULL) )
		res = _stricmp((char *)ci1->szContactInfo, (char *)ci2->szContactInfo);

	if ( (res == 0) && (ci1->szDisplay != NULL) && (ci2->szDisplay != NULL) )
		res = _stricmp((char *)ci1->szDisplay, (char *)ci2->szDisplay);
	
	return res;
}

int getSortType(char *type) {
	
	if ( (type == NULL) || (strlen(type) == 0) ) return 0;
	if (!_stricmp(type, STR_STATUS))
		return SORT_STATUS;
	
	else return getContactInfoType(type);
}